/****************************************************************************
 * Name:      backup.prg                                                    *
 * Task:      Backup files to removable media                               *
 *                                                                          *
 * A couple or 3 years ago I downloaded a file from the FidoNet Echo        *
 * Clipper group called "Per_Back".  The fellow that wrote it was of        *
 * Norwegian background, as I recall, and and his first name started with   *
 * "Per", hence the name of the file.   I incorporated the routines into    *
 * several of my applications, very slightly modified. I have lost the      *
 * originals, but present here the modifications.                           *
 *                                                                          *
 * In some of my program I have made the array of files to be backed up     *
 * a literal array of file names of the application,                        *
 *                                                                          8
 *                                                                          *
 * These functions use low-level fileio to write any set of files to        *
 * diskette.  Their main advantage, over simple copying is that they can    *
 * split files across 2 or more diskettes.  It is 100% Clipper and all      *
 * needed source is included here, including a demo calling routine.        *
 * The coding style is a little old fashioned, with mostly private variables*
 * being used.  I have replace a few, but not disturbed most due to the     *
 * original author's use of macro compilation and memory files.  Besides,   *
 * if it works, don't fix it.  I did ad 5.3 pushbuttons, though.            *
 *                                                                          *
 * Their main weakness, compared to a commercial product such as ProVision  *
 * Backup, which I now use instead, is that this routine does not format    *
 * diskettes on the fly and does not use any compression.  In addition      *
 * the estimated time display is wildly inaccurate, owing to the substantial*
 * speed differences in disk read/write times on the array of modern PCs    *
 * out there.  At the time this was written, most everything was still a    *
 * slow '386, at best. You may wish to adjust the value used on line 324    *
 * downward or upward, depending up the target platform. On my Pentium 90   *
 * 2900 bytes per second is about a fourth of what the computer is doing,   *
 * or less.                                                                 *
 *                                                                          *
 *                                                                          *
 * The original was placed in the Public domain, as are my modifications.   *
 *                                                                          *
 * Rick Newton CIS 75517,2410                                               *
 *                                                                          *
 *                                                                          *
 * Function:  HNEW()    New disk                                            *
 *            HPROMPT() Text on line 24                                     *
 *            HSORRY()  Popup window                                        *
 *                                                                          *
 * Procedure:                                                               *
 *            HSTAT     Display status                                      *
 *                                                                          *
 * Local:                                                                   *
 *            lrow      display pointer                                     *
 *            lclm      display pointer                                     *
 *            lbyte_tot bytes to be copied                                  *
 *            lbyte_cop bytes copied                                        *
 *            lfile_no  file number (ARRAY pointer)                         *
 *            lfiles    No of files to back up                              *
 *            lsource   Source file *.*                                     *
 *            lname     name of file without extension                      *
 *            linfile   F handle                                            *
 *            loutfile  F handle                                            *
 *            lxx       temporary                                           *
 *            lread     read value and bytes read                           *
 *            lwrite    bytes written                                       *
 *            ldrive    drive to backup to                                  *
 *            ldisk_no  disk number in use                                  *
 *            linc      no of bytes copied each time round the loop         *
 *            lbuffer   text buffer                                         *
 *            lpos      position in input file relative to 0                *
 *            lexit     logical counter                                     *
 *            lbackno   a number given a backup set                         *
 *            ARname[]  array with file names                               *
 *            ARsize[]  array with file sizes                               *
 ***************************************************************************/
#include "box.ch"



#ifdef TEST
FUNCTION MAIN()
LOCAL nChoice
WHILE .t.
     SETCOLOR("n/w,w+/n,,,m/w")
     @ 0,0,MAXROW(),MAXCOL() BOX B_SINGLE+"" COLOR "W+/b"
     @ 5,20,15,60 BOX B_SINGLE+" "
     @ 8,21 PROMPT PADC("Backup",39," ")
     @10,21 PROMPT PADC("Restore",39," ")
     @12,21 PROMPT PADC("Quit",39," ")
     MENU to nChoice
     DO CASE
          CASE nChoice == 1
              back_up()
          CASE nChoice == 2
              restore()
          CASE nChoice == 3
              SETCOLOR("w/n")
              SCROLL()
              QUIT
     ENDCASE
ENDDO
RETURN NIL
#endif



FUNCTION back_up()
LOCAL getlist := {}
LOCAL lrow,lclm,linfile,lxx,lread,;
     linc,lbuffer,loutfile,lpos,lexit,lwrite,lname,lfiles,lpath,lsource
LOCAL lDummy1  := .t.
LOCAL lDummy2  := .t.
LOCAL lgo      := .t.

PRIV lbackno
PRIV lfile
PRIV lfile_no
PRIV ldisk_no
PRIV ldrive
PRIV lbyte_tot
PRIV lbyte_cop


SET CURSOR OFF
SETCOLOR("w+/b,w+/n,,,w/b")
CLEAR
@  1, 0 TO 24,79
@  1, 2 SAY " BACKUP FILES TO FLOPPY DISKETTES "
@  7,40,21,75 BOX B_SINGLE+" "
@  7,41 SAY " STATUS "
@ 13,40 TO 13,75
@ 13,40 SAY ""
@ 13,75 SAY ""

lbackno = SECONDS()    // A serial number for the backup set
@  3, 5 SAY "Source Drive\path..."
@  4, 5 SAY "Source file ........"
@  5, 5 SAY "Target Drive........"
@  8,42 SAY "Estimated Time......"
@  9,42 SAY "Bytes to Copy......."
@ 11,42 SAY "Bytes Copied........"
@ 12,42 SAY "Completed...........           %"
@ 14,42 SAY "Diskettes Needed:"
@ 16,42 SAY '5 "  360 Kb........'
@ 17,48 SAY "1.2 Mb........"
@ 19,42 SAY '3 "  720 Kb........'
@ 20,48 SAY "1.4 Mb........"

******************************************************************************
DO WHIL .T.
   lpath   := DISKNAME()+":\"+CURDIR()+"\"
   lpath   := lpath+SPAC(30-LEN(lpath))
   lsource := "*.*         "
   m->ldrive  := "A"
   HPROMPT("Enter Source: path and file info, Target drive                      [ESC]-Quit")
   @ 3,27 GET lpath
   @ 4,27 GET lsource
   @ 5,27 GET m->ldrive PICT "@A !"

   @ 7,5 GET ldummy1 PUSHBUTTON CAPTION "   Go   " STATE {||lGo := .t.,READKILL(.t.)} STYLE B_SINGLE
   @10,5 GET ldummy1 PUSHBUTTON CAPTION " Cancel " STATE {||lGo := .f.,READKILL(.t.)} STYLE B_SINGLE
   SET CURSOR ON
   READ
   SET CURSOR OFF
   lpath:=TRIM(lpath)
   lsource:=TRIM(lsource)
   IF ! m->ldrive $"AB"
     HSORRY("SORRY, Drive does not contain a removable media")
   ELSE
     lfiles := ADIR(lpath+lsource)      // See how many .dbt & .dbf files
     IF lfiles = 0
        HSORRY("Sorry, No files found")
     ELSE
        EXIT
     ENDIF
   ENDIF
ENDDO

IF LASTKEY()<>27 .AND. lgo
 SCROLL(6,1,15,30)  //erase buttons
 //****************** Read file names into Array and count bytes ****************
 lbyte_tot = 0                       // bytes to be backed up
 lbyte_cop = 0                       // bytes backed up so far
 /*
     Another approach is to declare a literal array
     of files you want backed up and dispense with
     GET lsource and lpath on line 153,154

     PRIV arname := {}
     PRIV arsize := 0

     AADD(arname,"WH1.DBF")
     AADD(arname,"WH1.DBV")
     AADD(arname,"FINDINGS.DBF")
     lfiles = LEN(arname)

 */

 PRIV ARname[lfiles]
 PRIV ARsize[lfiles]
 // comment out line below if you use a literal array of file name
 ADIR(lpath+lsource,ARname,ARsize) // read names to ARname[], sizes to ARsize
 FOR lxx = 1 TO lfiles
   lbyte_tot = lbyte_tot + ARsize[lxx]
 NEXT
 //******************************************************************************

 DO HSTAT
 //******************* Display number of disks needed **************************
 lxx=lbyte_tot/360000
 @ 16,63 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1200000
 @ 17,63 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/720000
 @ 19,63 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 lxx=lbyte_tot/1400000
 @ 20,63 SAY LTRIM(STR(IF(lxx>INT(lxx),INT(lxx)+1,INT(lxx))))
 *****************************************************************************

 linc     = 1024
 lrow     = 8
 lclm     = 5
 m->ldisk_no = 1

 IF HNEW()

  FOR lfile_no = 1 TO lfiles

   lbuffer  = SPAC(linc)
   lname    = ARname[lfile_no]
   linfile  = FOPEN(lpath+lname)            // Open the source file
   loutfile = FCREATE(m->ldrive+":"+lname)  // Create the target file
   lpos     = 0
   lexit    = .F.

   @ lrow,lclm SAY lname
   SETCOLOR("w+/b")
   @ lrow,lclm+12 SAY " *"

   DO WHIL .T.
    lread     = FREAD(linfile,@lbuffer,linc)    && read buffer
    lwrite    = FWRITE(loutfile,lbuffer,lread)  && write buffer
    lpos      = lpos+lwrite
    lbyte_cop = lbyte_cop+lwrite
    DO HSTAT
    IF lwrite < lread                  // THE WHOLE FILE DID NOT FIT
       FSEEK(linfile,lpos)             // position pointer where text ended
       FCLOSE(loutfile)                // close the outfile
       m->ldisk_no = m->ldisk_no+1     // increment disk number
       IF HNEW()
          loutfile = FCREATE(m->ldrive+":"+lname)  && continue on a new disk
       ELSE
          lexit = .T.                  // user decided to Quit
          EXIT
       ENDI
    ELSE
       IF lread = 0                    // File has been successfully copied
          @ lrow,lclm+12 SAY " "
          lclm=IF(lrow<>22,lclm,IF(lclm=23,5,23))
          lrow=IF(lrow<>22,lrow+1,8)
          EXIT
       ENDI
    ENDI
   ENDD

   FCLOSE(linfile)
   FCLOSE(loutfile)

   IF lexit
      @ lrow,lclm+12 SAY "  "
      EXIT
   ENDI

  NEXT

  IF ! lexit
   HSORRY("BACKUP COMPLETED")
  ENDI

 ENDI
ENDI

SET CURSOR ON
CLEAR
RETURN NIL



FUNCTION HNEW()           // prompt for a new disk
LOCAL lScreen := SAVESCREEN(21,0,23,79)
LOCAL lxx
LOCAL ltemp

PRIV PX_disk,PX_number,PX_byte


DO WHILE .T.
   lxx := "PLEASE Put Backup Disk No ["+STR(m->ldisk_no,2)+"] in Target drive ["+m->ldrive+"]"
   @ 21,(76-LEN(lxx))/2,23,(82+LEN(lxx))/2 BOX ""
   @ 22,(80-LEN(lxx))/2 SAY lxx

   HPROMPT("Wait Mode:                 Press ANY KEY to Continue                [ESC]-Quit")
   IF INKEY(0)=27      // WAIT
      RESTSCREEN(21,0,23,79,lscreen)
      RETU .F.        // --------> [ESC]
   ELSE
      HPROMPT("Backup:                       DISK ACCESS                           [ESC]-Quit")
      lxx := FCREATE(m->ldrive+":temp")
      IF lxx<>-1       // disk is write ready
         ERASE &ldrive.:temp
         IF FILE(m->ldrive+":per_back.mem")
            REST FROM &ldrive.:per_back.mem ADDI
         ELSE
            PX_disk   := m->ldisk_no
            PX_number := 0
         ENDIF
         IF (PX_disk<m->ldisk_no.AND.PX_number<>lbackno).OR.PX_disk>=m->ldisk_no  // All test passed
            //******* deleting all files on target ****************
            ltemp := ADIR(m->ldrive+":*.*")  // count files meeting wildcard
            PRIV ARtemp[ltemp]
            ADIR(m->ldrive+":*.*",ARtemp)    // read names to ARtemp[]
            FOR lxx = 1 TO ltemp
              lfile := ARtemp[lxx]
              ERASE &m->ldrive.:&lfile
            NEXT
            *****************************************************
            PX_disk   := m->ldisk_no
            PX_number := lbackno
            PX_byte   := lbyte_tot
            SAVE TO &ldrive.:per_back.mem ALL LIKE PX_*
            RESTSCREEN(21,0,23,79,lscreen)
            RETURN .T.
         ELSE
            HSORRY("Sorry, This disk has already been used")
         ENDI
      ELSE
         HSORRY("Sorry, No disk in drive or Write-protected / Unformatted disk")
      ENDIF
   ENDIF
ENDDO
RETURN NIL


FUNCTION HSTAT()       // progress status
LOCAL ltime

ltime = (lbyte_tot-lbyte_cop)/2900    // I found speed to be approx 2900 b/sec

@  8,66 SAY SUBS(STR(INT(ltime/3600%24)+10^2,2+1),2)+":"+;   // Hours
            SUBS(STR(INT(ltime/60%60)+10^2,2+1),2)+":"+;     // Minutes
            SUBS(STR(INT(ltime%60)+10^2,2+1),2)              // Seconds
@  9,63 SAY TRAN(lbyte_tot-lbyte_cop,"999,999,999")
@ 11,63 SAY TRAN(lbyte_cop,"999,999,999")
@ 12,69 SAY TRAN(ROUND(lbyte_cop/lbyte_tot*100,0),"999")

RETURN NIL


/****************************************************************************
 * Syntax:   HSORRY(<expC>)                                                 *
 * Argument: <expC> is string to be shown on screen.                        *
 * Return:   .T.                                                            *
 * Usage:    Used to display a message when the user has made a misstake.   *
 * Note:     The message is placed in a box, and is allways displayed on    *
 *           line 21.                                                       *
 * Example:  HSORRY("Sorry, The name is not valid")                         *
 ***************************************************************************/
FUNC HSORRY(lString)
LOCAL lScreen := SAVESCREEN(20,0,22,79)
 TONE(900,1)
 TONE(900,1)
 TONE(900,1)
 TONE(900,2)
 @ 20,(76-LEN(lstring))/2,22,(82+LEN(lstring))/2 BOX ""
 @ 21,(80-LEN(lstring))/2-1 SAY " "+lstring+" "
 HPROMPT("                        Press ANY key to continue")
 INKEY(0)
 RESTSCREEN(20,0,22,79,lscreen)

RETURN .T.






/****************************************************************************
 * Syntax:   HPROMPT(<expC>)                                                *
 * Argument: <expC> is the text to be displayed on line 24 in inverse.      *
 * Return:   .T.                                                            *
 * Usage:    To display a prompt line corresponding to current action.      *
 * Note:                                                                    *
 * Example:  HPROMPT("text on line 24")                                     *
 ***************************************************************************/

FUNC HPROMPT(lString)
@ 24,1 SAY lstring+SPACE(78-LEN(lstring))
RETURN .T.

