
/****************************************************************************
 * Name:      WH_Rest.prg                                                   *
 * Task:      Restore files from removable media                            *
 *                                                                          *
 * Function:  HREST()    New disk             (3 procedures in WH_BACK.PRG) *
 *            HPROMPT()  Text on line 24                                    *
 *            HSORRY()   Popup window                                       *
 * Procedure:                                                               *
 *            HSTAT     Display copying progress                            *                                  *
 * Local:                                                                   *
 *            lrow      display pointer                                     *
 *            lclm      display pointer                                     *
 *            lbyte_tot bytes to be copied                                  *
 *            lbyte_cop bytes copied                                        *
 *            lfile_no  file number (ARRAY pointer)                         *
 *            lname     name of file without extension                      *
 *            lback     name of file with .bak extension                    *
 *            linfile   F handle                                            *
 *            loutfile  F handle                                            *
 *            lxx       temporary                                           *
 *            lread     read value and bytes read                           *
 *            lwrite    bytes written                                       *
 *            ldrive    drive to backup to                                  *
 *            ldisk_no  disk number in use                                  *
 *            linc      no of bytes copied each time round the loop         *
 *            lbuffer   text buffer                                         *
 *            lpos      position in input file relative to 0                *
 *            lexit     logical counter                                     *
 *            lbackno   a number given a backup set                         *
 *            ARcopy[]  array with file names of each disk                  *
 ****************************************************************************/
#include "box.ch"
PRIV lrow,lclm,lbyte_tot,lbyte_cop,lfile_no,linfile,lxx,lread,ldrive,lbackno,;
     ldisk_no,linc,lbuffer,loutfile,lpos,lexit,lwrite,lname,lback,lscreen

PRIV PX_disk,PX_number,PX_byte

SET CURSOR OFF
SETCOLOR("w+/g,w+/n,,n/g")
CLEAR
@  1, 0 TO 24,79
@  1, 2 SAY " RESTORE FILES FROM FLOPPY DISKETTES "
@  6,40,13,75 BOX B_SINGLE+" "
@  6,41 SAY " STATUS "

@  3,5  SAY "Source Drive........"
@  4,5  SAY "Target Drive/path..."
@  8,42 SAY "Estimated Time......"
@  9,42 SAY "Bytes to Copy......."
@ 11,42 SAY "Bytes Copied........"
@ 12,42 SAY "Completed...........           %"


*******************************************************************************
DO WHIL .T.
   lpath   = DISKNAME()+":\"+CURDIR()+"\"
   lpath   = lpath+SPAC(30-LEN(lpath))
   ldrive  = "A"
   HPROMPT("Enter Source: path and file info, Target drive                      [ESC]-Quit")
   @ 3,27 GET ldrive PICT "@A !"
   @ 4,27 GET lpath
   SET CURSOR ON
   READ
   SET CURSOR OFF
   lpath:=TRIM(lpath)
   IF ! ldrive $"AB"
     HSORRY("SORRY, Drive does not contain a removable media")
   ELSE
     lxx = FCREATE(lpath+"temp")
     IF lxx = -1
        HSORRY("Sorry, Target drive and path not found")
     ELSE
        FCLOSE(lxx)
        ERASE &lpath.temp
        EXIT
     ENDI
   ENDI
ENDD

IF LASTKEY()<>27

 lrow      := 8
 lclm      := 5
 lbackno   := 0
 linc      := 1024
 lback     := ""
 lname     := ""
 lbyte_tot := 0
 lbyte_cop := 0
 ldisk_no  := 1

 DO WHIL .T.
    lscreen  = SAVESCREEN(21,0,23,79)
    lxx := "PLEASE Put Backup Disk No ["+STR(ldisk_no,2)+"] in Source drive ["+ldrive+"]"
    @ 21,(76-LEN(lxx))/2,23,(82+LEN(lxx))/2 BOX ""
    @ 22,(80-LEN(lxx))/2 SAY lxx

    HPROMPT("Wait Mode:                 Press ANY KEY to Continue                [ESC]-Quit")
    IF INKEY(0)=27     // WAIT
       RESTSCREEN(21,0,23,79,lscreen)
       EXIT            // --------> [ESC]
    ELSE
       HPROMPT("Backup:                       DISK ACCESS                           [ESC]-Quit")
       IF FILE(ldrive+":per_back.mem")
          REST FROM &ldrive.:per_back.mem ADDI
          IF PX_disk = ldisk_no
             IF (PX_number=lbackno).OR.ldisk_no=1  // ALL CONTROLS PASSED
                IF ldisk_no  = 1
                   lbyte_tot := PX_byte     // bytes to copy
                   lbackno   := PX_number
                   DO HSTAT
                ENDIF
                PRIV ARcopy[ADIR(ldrive+":*.*")]
                ADIR(ldrive+":*.*",ARcopy)
                RESTSCREEN(21,0,23,79,lscreen)
                IF HREST()   //--------> DO DISK READ ROUTINE
                   EXIT
                ENDIF
                ldisk_no++                        // increment disk number
             ELSE
                HSORRY("Sorry, The diskette does not belong to this backup set")
             ENDIF
          ELSE
             HSORRY("Sorry, This is not the correct disk number")
          ENDIF
       ELSE
          HSORRY("Sorry, No disk in drive or Not a backup disk")
       ENDIF
    ENDIF
 ENDDO

 IF lbyte_cop <> lbyte_tot   // ESCAPED while restore not complete
    ERASE &lpath.&lname
    RENAME &lpath.&lback TO &lpath.&lname
    lbyte_cop = lbyte_cop-lpos
    DO HSTAT
    @ lrow,lclm+12 SAY " -"
 ENDI

ENDI

SET CURS ON
CLEAR
RETU

//******************************************************************************
//******************************************************************************
FUNC HREST      // restore files from one disk

lexit := .F.

FOR lfile_no = 2 TO LEN(ARcopy)   // (skips 1 -> per_back.mem)

    IF lname = ARcopy[lfile_no]                     // APPEND TO FILE
       loutfile = FOPEN(lpath+lname,2)
       FSEEK(loutfile,0,2)   // move to end of file
    ELSE                                            // MAKE NEW FILE
       IF lbyte_cop > 0
          @ lrow,lclm+12 SAY " "
          lclm=IF(lrow<>22,lclm,IF(lclm=23,5,23))
          lrow=IF(lrow<>22,lrow+1,8)
       ENDI
       ERASE &lpath.&lback
       lname = ARcopy[lfile_no]
       IF FILE(lpath+lname)
          lback = LEFT(lname,LEN(lname)-4)+".bak"
          RENAME &lpath.&lname TO &lpath.&lback
       ENDI
       loutfile = FCREATE(lpath+lname)             // Create the target file
       @ lrow,lclm SAY lname
       @ lrow,lclm+12 SAY " *"
    ENDI

    linfile  = FOPEN(ldrive+":"+lname)      // Open the source file
    lbuffer  = SPAC(linc)
    lpos     = 0

    DO WHIL .T.
       lread     = FREAD(linfile,@lbuffer,linc)
       lwrite    = FWRITE(loutfile,lbuffer,lread)
       lpos      = lpos+lwrite
       lbyte_cop = lbyte_cop+lwrite
       DO HSTAT
       IF lwrite < lread      // SOMETHING WENT WRONG
          HSORRY("Sorry, a DOS disk access error has occured"+STR(FERROR(),3))
          lexit = .T.
          EXIT
       ELSE
          IF lread = 0    // File has been successfully copied
             EXIT
          ENDIF
       ENDIF
    ENDDO

    FCLOSE(linfile)
    FCLOSE(loutfile)

    IF lexit
       EXIT
    ENDI

NEXT

IF (lbyte_cop = lbyte_tot)
   ERASE &lpath.&lback
   @ lrow,lclm+12 SAY " "
   HSORRY("RESTORE COMPLETE")
   lexit=.T.
ENDI

RETU lexit


























